# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/).


## [Unreleased]

### Added
- placeholder

### Changed
- placeholder

### Removed
- placeholder

### Fixed
- placeholder


## [0.1.7] - 2021-04-22

### Added
- Changelog was added, to increase the traceability of changes to the project and software.
- Flip&Stitch plugin, that can be used to stitch images that were taken with the help of a measuring field extension.
- The possibility to create an unperfect reconstruction. That means, you can tell TOMIS to use the outer areas of the 
  images even if (because of the detector angle) there is no data for every slice.
- Error handling for bug reporting on installations, that are not managed by conda.
- More options to the DECT plugin and made it work with raw files.

### Changed
- When images are saved as tif files, the first image no longer gets handled differently. Before, the first image was 
  saved with additional info-parameters (resolution infos) in the tif-header. If the same data should be loaded by 
  TOMIS, the header of the first image was read and used for all other images, which resulted in TOMIS throwing an 
  error for all images except the first.
- Setup.py to generate a folder with the current date as the name and copy all files relevant for distribution of 
  tomis there. The tools and notebooks are now included.
- README.txt to make explanations clearer.

### Removed
- PyQt5 imports

### Fixed
- A bug that was preventing images to be saved. Which therefore made the program unusable for reconstructions. This bug 
  was introduced in the major refactoring in the last version. 
- A bug in the DECT plugin that was using way too much RAM while loading the BPM.
- Path to the manual. It should be possible to open it again. Just use the menu bar -> Help -> Manual.


## [0.1.6] - 2021-02-19

### Added
- The possibility to create a feature request or a bug report from TOMIS itself. Just use the menu bar -> Help -> 
  Create Feature Request or menu bar -> Help -> Create Bug Report.
- DECT plugin, that can be used to enhance images by combining two CT-scans of the same object, that were taken with 
  different energies.
- A checkbox called load info was added under Projections in the Data Input Configuration dialog. Now the user can 
  decide if information from an info file should be loaded and if this information should be used to overwrite the 
  existing settings, or not. The information is loaded as soon as the checkbox is checked. At the moment loading the 
  shape is the only information that is loaded.
- Templates for bug report and feature request issues were added to the project repository.  

### Changed
- Setup.py to include a yml file to make a new installation of TOMIS even easier. With this file, a conda environment, 
  that includes all necessary packages to run TOMIS can be installed in a few minutes.
- Major refactoring of the whole project by unifying the imports and reorganization of the file and folder structure.
- Correction of images. Before, some combinations of dark and ref where accepted that made no sense and therefore threw 
  errors. Now, there are three implicit options. If ref and dark are not checked, no correction will be done. If ref is 
  checked, a completely black dark will be generated and correction is done with refs and the generated dark. If ref 
  and dark is checked, both will get used for correction. It is no longer possible to check and use a dark without 
  checking ref.

### Removed
- With the major refactoring, the control capabilities for different detectors and motors are no longer part of TOMIS. 
  From now on, these capabilities will be handled by ROSCT.

### Fixed
- Ambiguous image module / parameter shadowing.
- PySide2/PyQt5 imports. GUI is now able to start on Windows and Linux.
- A bug that still wanted to correct images, while ref and dark were unchecked. This happend, when ref and dark were 
  checked previously.
- A problem while loading settings. If settings were loaded the current widgets were deleted and before the widgets 
  were repopulated the program tried to load them again. So this step is avoided as long as there are no widgets.  
- Cropping while using a bad pixel map.  


## [0.1.5] - 2020-11-18

### Added
- Gitignore file.
- Remaining files that were not yet checked in.

### Fixed
- Problem with loading of the dll used by the rayence detector.


## [<= 0.1.4] - 2020-01-16 until 2020-06-09

### Added
- Initial creation of project structure for TOMIS. TOMIS is a combination of several previously independent software 
  tools. The tools are pyXIT, pyPCP, pyETX and control capabilities for different detectors and motors.
